/**
 * an example to demonstrate the importance of being
 * equal (in the correct logical sense).
 */

class A {
	
	private int field1;
	// private char field2;
	private String field2;
	
	public A(int i, String s) {
		this.field1 = i;
		this.field2 = new String(s);
	}
	
	public int getField1() {
		return field1;
	}
	
	public String getField2() {
		return field2;
	}
	
	// this demonstrates that it is important to override the equals method
	// to explore _wrong_ version -- comment out equals() overriding
	
	@Override 
	public boolean equals(Object o) {
		
		if (!(o instanceof A))
			return false;
		A a = (A) o;
			return (this.field1 == a.field1) && 
					(this.field2.equals(a.field2));
	} 
}
